package com.hr.service;

import com.hr.param.InterfaceConfigParam;
import com.hr.param.IpInterfaceParam;
import com.hr.param.SwitchStatusParam;
import com.hr.repository.domain.IpInterfacePO;
import com.hr.vo.IpInterfaceVO;
import com.hr.vo.NameValueVO;
import com.yy.basedevelop.common.data.BasePageResult;
import com.yy.basedevelop.dto.LoginUser;

import java.util.List;

/**
 * 接口表;(ip_interface)表服务接口
 * @author : http://www.yonsum.com
 * @date : 2025-10-10
 */
public interface IpInterfaceService{
    
    /** 
     * 通过ID查询单条数据 
     *
     * @param iid 主键
     * @return 实例对象
     */
    IpInterfaceVO queryById(Long iid);
    
    /**
     * 分页查询
     *
     * @param interfaceParam 筛选条件
     * @param current 当前页码
     * @param size  每页大小
     * @return
     */
    BasePageResult<IpInterfaceVO> paginQuery(IpInterfaceParam interfaceParam, Integer current, Integer size);
    /** 
     * 新增数据
     *
     * @param IpInterfacePO 实例对象
     * @return 实例对象
     */
    void insert(IpInterfacePO IpInterfacePO);
    /** 
     * 更新数据
     *
     * @param IpInterfacePO 实例对象
     * @return 实例对象
     */
    void update(IpInterfacePO IpInterfacePO);
    /**
     * 通过主键删除数据
     *
     * @param iid  主键
     * @param user
     * @return 是否成功
     */
    boolean deleteById(Long iid, LoginUser user);

    void saveOrUpdate(IpInterfaceParam ipInterfaceParam, String username, Long userid);

    Boolean switchStatus(SwitchStatusParam switchStatusParam);

    List<NameValueVO> optionList();

    void interfaceConfig(InterfaceConfigParam param);

    IpInterfaceVO queryByInterfaceCode(String interfaceCode);
}